#define via_b         $0300
#define via_a         $0301
#define via_ddrb      $0302
#define via_ddra      $0303

.text

_ijk_present      .byt  0

_ijk_joy_left     .byt  0
_ijk_joy_right    .byt  0

_ijk_detect
          php
          sei

          ;ensure printer strobe is set to output
          lda #%10110111
          sta via_ddrb

          ;set strobe low
          lda #%00000000
          sta via_b

          ;set top two bits of porta to output and rest as input
          lda #%11000000
          sta via_ddra

          lda #%11000000
          sta via_a

          lda via_a
          and #%00100000
          eor #%00100000
          sta _ijk_present

          ; beq ijk_absent
          ; bne ijk_present

          ;restore via porta state
          lda #%11111111
          sta via_ddra

          plp
          rts

ijk_bits
          .byt 0,2,1,3,32,34,33,0,8,10,9,0,40,42,41,0
          .byt 16,18,17,0,48,50,49,0,0,0,0,0,0,0,0,0

_ijk_read
         ;ensure printer strobe is set to output
         lda #%10110111
         sta via_ddrb
         ;set strobe low
         lda #%00000000
         sta via_b
         ;set top two bits of porta to output and rest as input
         lda #%11000000
         sta via_ddra
         ;select left joystick
         lda #%01111111
         sta via_a
         ;read back left joystick state
         lda via_a
         ;mask out unused bits
         and #%00011111
         ;invert bits
         eor #%00011111
         ;index table to conform to generic format
         tax
         lda ijk_bits,x
         sta _ijk_joy_left
         ;select right joystick
         lda #%10111111
         sta via_a
         ;read back right joystick state and rejig bits
         lda via_a
         and #%00011111
         eor #%00011111
         tax
         lda ijk_bits,x
         sta _ijk_joy_right
         ;restore via porta state
         lda #%11111111
         sta via_ddra
         rts
